const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const payments = sequelize.define(
    'payments',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

provider: {
        type: DataTypes.ENUM,
      
      

        values: [

"dana_snap"

        ],

      },

provider_reference: {
        type: DataTypes.TEXT,
      
      

      },

checkout_url: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"initiated",


"pending",


"paid",


"failed",


"expired",


"refunded"

        ],

      },

amount: {
        type: DataTypes.DECIMAL,
      
      

      },

currency_code: {
        type: DataTypes.TEXT,
      
      

      },

initiated_at: {
        type: DataTypes.DATE,
      
      

      },

confirmed_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  payments.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


















    db.payments.hasMany(db.payment_events, {
      as: 'payment_events_payment',
      foreignKey: {
          name: 'paymentId',
      },
      constraints: false,
    });


    db.payments.hasMany(db.refunds, {
      as: 'refunds_payment',
      foreignKey: {
          name: 'paymentId',
      },
      constraints: false,
    });










//end loop



    db.payments.belongsTo(db.orders, {
      as: 'order',
      foreignKey: {
        name: 'orderId',
      },
      constraints: false,
    });



    db.payments.hasMany(db.file, {
      as: 'raw_payload_files',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.payments.getTableName(),
        belongsToColumn: 'raw_payload_files',
      },
    });


    db.payments.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.payments.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return payments;
};


